Name:           ros-jazzy-ur-robot-driver
Version:        3.2.0
Release:        1%{?dist}
Summary:        ROS package ur-robot-driver

License:        BSD-3-Clause
URL:            http://www.ros.org/

Source0:        https://github.com/ros2-gbp/Universal_Robots_ROS2_Driver-release/archive/release/jazzy/ur_robot_driver/3.2.0-1.tar.gz#/ros-jazzy-ur-robot-driver-3.2.0-source0.tar.gz



# common BRs
BuildRequires: patchelf
BuildRequires: coreutils
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: make
BuildRequires: patch
BuildRequires: python3-devel
BuildRequires: python-unversioned-command
BuildRequires: python3-colcon-common-extensions
BuildRequires: python3-pip
BuildRequires: python3-pydocstyle
BuildRequires: python3-pytest
BuildRequires: python3-pytest-repeat
BuildRequires: python3-pytest-rerunfailures
BuildRequires: python3-rosdep
BuildRequires: python3-setuptools
BuildRequires: python3-vcstool

# BuildRequires:  boost-devel
# BuildRequires:  console-bridge-devel
# BuildRequires:  gtest-devel
# BuildRequires:  log4cxx-devel
# BuildRequires:  python3-devel
# BuildRequires:  python3-colcon-common-extensions
# BuildRequires:  python-unversioned-command

BuildRequires:  ros-jazzy-ament-cmake
BuildRequires:  ros-jazzy-ament-cmake-python
BuildRequires:  ros-jazzy-ament-package
BuildRequires:  ros-jazzy-backward-ros
BuildRequires:  ros-jazzy-controller-manager
BuildRequires:  ros-jazzy-controller-manager-msgs
BuildRequires:  ros-jazzy-geometry-msgs
BuildRequires:  ros-jazzy-hardware-interface
BuildRequires:  ros-jazzy-pluginlib
BuildRequires:  ros-jazzy-rclcpp
BuildRequires:  ros-jazzy-rclcpp-lifecycle
BuildRequires:  ros-jazzy-rclpy
BuildRequires:  ros-jazzy-std-msgs
BuildRequires:  ros-jazzy-std-srvs
BuildRequires:  ros-jazzy-tf2-geometry-msgs
BuildRequires:  ros-jazzy-ur-client-library
BuildRequires:  ros-jazzy-ur-controllers
BuildRequires:  ros-jazzy-ur-dashboard-msgs
BuildRequires:  ros-jazzy-ur-description
BuildRequires:  ros-jazzy-ur-msgs

Requires:       socat
Requires:       ros-jazzy-backward-ros
Requires:       ros-jazzy-controller-manager
Requires:       ros-jazzy-controller-manager-msgs
Requires:       ros-jazzy-force-torque-sensor-broadcaster
Requires:       ros-jazzy-geometry-msgs
Requires:       ros-jazzy-hardware-interface
Requires:       ros-jazzy-joint-state-broadcaster
Requires:       ros-jazzy-joint-state-publisher
Requires:       ros-jazzy-joint-trajectory-controller
Requires:       ros-jazzy-launch
Requires:       ros-jazzy-launch-ros
Requires:       ros-jazzy-pluginlib
Requires:       ros-jazzy-pose-broadcaster
Requires:       ros-jazzy-position-controllers
Requires:       ros-jazzy-rclcpp
Requires:       ros-jazzy-rclcpp-lifecycle
Requires:       ros-jazzy-rclpy
Requires:       ros-jazzy-robot-state-publisher
Requires:       ros-jazzy-ros2-controllers-test-nodes
Requires:       ros-jazzy-rviz2
Requires:       ros-jazzy-std-msgs
Requires:       ros-jazzy-std-srvs
Requires:       ros-jazzy-tf2-geometry-msgs
Requires:       ros-jazzy-ur-client-library
Requires:       ros-jazzy-ur-controllers
Requires:       ros-jazzy-ur-dashboard-msgs
Requires:       ros-jazzy-ur-description
Requires:       ros-jazzy-ur-msgs
Requires:       ros-jazzy-urdf
Requires:       ros-jazzy-velocity-controllers
Requires:       ros-jazzy-xacro

Requires:       ros-jazzy-ament-cmake
Requires:       ros-jazzy-ament-cmake-python
Requires:       ros-jazzy-ament-package
Requires:       ros-jazzy-backward-ros
Requires:       ros-jazzy-controller-manager
Requires:       ros-jazzy-controller-manager-msgs
Requires:       ros-jazzy-geometry-msgs
Requires:       ros-jazzy-hardware-interface
Requires:       ros-jazzy-pluginlib
Requires:       ros-jazzy-rclcpp
Requires:       ros-jazzy-rclcpp-lifecycle
Requires:       ros-jazzy-rclpy
Requires:       ros-jazzy-std-msgs
Requires:       ros-jazzy-std-srvs
Requires:       ros-jazzy-tf2-geometry-msgs
Requires:       ros-jazzy-ur-client-library
Requires:       ros-jazzy-ur-controllers
Requires:       ros-jazzy-ur-dashboard-msgs
Requires:       ros-jazzy-ur-description
Requires:       ros-jazzy-ur-msgs
Requires:       ros-jazzy-force-torque-sensor-broadcaster
Requires:       ros-jazzy-joint-state-broadcaster
Requires:       ros-jazzy-joint-state-publisher
Requires:       ros-jazzy-joint-trajectory-controller
Requires:       ros-jazzy-launch
Requires:       ros-jazzy-launch-ros
Requires:       ros-jazzy-pose-broadcaster
Requires:       ros-jazzy-position-controllers
Requires:       ros-jazzy-robot-state-publisher
Requires:       ros-jazzy-ros2-controllers-test-nodes
Requires:       ros-jazzy-rviz2
Requires:       ros-jazzy-urdf
Requires:       ros-jazzy-velocity-controllers
Requires:       ros-jazzy-xacro

Provides:  ros-jazzy-ur-robot-driver = 3.2.0-1
Obsoletes: ros-jazzy-ur-robot-driver < 3.2.0-1


%description
The new driver for Universal Robots UR3, UR5 and UR10 robots with CB3
controllers and the e-series.




%prep

%setup -c -T
tar --strip-components=1 -xf %{SOURCE0}

%build
# nothing to do here


%install

PYTHONUNBUFFERED=1 ; export PYTHONUNBUFFERED
GZ_BUILD_FROM_SURCE=1; export GZ_BUILD_FROM_SOURCE
export GZ_VERSION=harmonic;

CFLAGS=" -Wno-error ${CFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CFLAGS ; \
CXXFLAGS=" -Wno-error ${CXXFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CXXFLAGS ; \
FFLAGS=" -Wno-error ${FFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FFLAGS ; \
FCFLAGS="${FCFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FCFLAGS ; \
%{?__global_ldflags:LDFLAGS="${LDFLAGS:-%__global_ldflags}" ; export LDFLAGS ;} \

source %{_libdir}/ros-jazzy/setup.bash

# substitute shebang before install block because we run the local catkin script
%py3_shebang_fix .

# DESTDIR=%{buildroot} ; export DESTDIR

colcon \
  build \
  --merge-install \
  --cmake-args -DPYTHON_EXECUTABLE="/usr/bin/python" \
  -DTHIRDPARTY_Asio=ON \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_CXX_FLAGS="$CXXFLAGS" \
  -DCMAKE_C_FLAGS="$CFLAGS" \
  -DCMAKE_LD_FLAGS="$LDFLAGS" \
  -DBUILD_TESTING=OFF \
  -Dgz_add_get_install_prefix_impl_OVERRIDE_INSTALL_PREFIX_ENV_VARIABLE="%{_libdir}/ros-jazzy/opt/" \
  --base-paths . \
  --install-base %{buildroot}/%{_libdir}/ros-jazzy/ \
  --packages-select ur_robot_driver



# remove wrong buildroot prefixes
# find %{buildroot}/%{_libdir}/ros-jazzy/ -type f -exec sed -i "s:%{buildroot}::g" {} \;
# we should exclude binaries from that as it might corrupt shared libraries
find %{buildroot}/%{_libdir}/ros-jazzy/ -type f ! -name '*.so*' -exec sh -c 'file "{}" | grep -q text && sed -i "s:%{buildroot}::g" "{}"' \;

# # Move include directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/include ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy/include/ur_robot_driver ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy/include/ur_robot_driver
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/include/* %{buildroot}/%{_libdir}/ros-jazzy/include/ur_robot_driver/
#     rm -rd %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/include
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/extra_cmake ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/extra_cmake ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/extra_cmake
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/extra_cmake/* %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/extra_cmake/
#     rm -rd %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/extra_cmake
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/share ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy/share/ur_robot_driver ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy/share/ur_robot_driver
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/share/* %{buildroot}/%{_libdir}/ros-jazzy/share/ur_robot_driver/
#     rm -rd %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/share
# fi

# # Move other opt path if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/* %{buildroot}/%{_libdir}/ros-jazzy/
#     rm  -rd %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver
# fi

rm -rf %{buildroot}/%{_libdir}/ros-jazzy/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# vendor pkg removal
rm -rf %{buildroot}/%{_libdir}/ros-jazzy/opt/share/ur_robot_driver/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# remove __pycache__
find %{buildroot} -type d -name '__pycache__' -exec rm -rf {} +
find . -name '*.pyc' -delete

touch files.list
find %{buildroot}/%{_libdir}/ros-jazzy/{share,bin,etc,tools,lib64/python*,lib/python*/site-packages,lib/python*/dist-packages} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" > files.list
find %{buildroot}/%{_libdir}/ros-jazzy/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list

# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/ur_robot_driver \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list

find %{buildroot}/%{_libdir}/ros-jazzy/{lib*/pkgconfig,include/,cmake/,ur_robot_driver/include/,share/ur_robot_driver/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-jazzy/ur_robot_driver/{lib*/pkgconfig,include/,cmake/,extra_cmake/,ur_robot_driver/include/,share/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/extra_cmake \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/ur_robot_driver/{lib*/pkgconfig,include/,cmake/,ur_robot_driver/include/,/share/cmake,/extra_cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/ament_index/resource_index \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/colcon-core/packages/ \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/ur_robot_driver/{hook,environment,cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find . -maxdepth 1 -type f -iname "*license*" | sed "s:^:%%license :" >> files.list



find %{buildroot}/%{_libdir}/ros-jazzy/ -name *__rosidl_generator_py.so -type f -exec patchelf --remove-rpath  {} \;
# find %{buildroot}/%{_libdir}/ros-jazzy/ -name *__rosidl_generator_py.so -type f -exec patchelf --force-rpath --add-rpath "%{_libdir}/ros2/lib" {} \;
find %{buildroot}/%{_libdir}/ros-jazzy/ -name "*.so*" -type f -exec patchelf  --shrink-rpath --allowed-rpath-prefixes %{_libdir} {} \;

# replace cmake python macro in shebang
for file in $(grep -rIl '^#!.*@PYTHON_EXECUTABLE@.*$' %{buildroot}) ; do
  sed -i.orig 's:^#!\s*@PYTHON_EXECUTABLE@\s*:%{__python3}:' $file
  touch -r $file.orig $file
  rm $file.orig
done


echo "This is a package automatically generated with rosfed." >> README_FEDORA
echo "See  https://github.com/TarikViehmann/rosfed for more information." >> README_FEDORA
install -m 0644 -p -D -t %{buildroot}/%{_docdir}/%{name} README_FEDORA
echo %{_docdir}/%{name} >> files.list

%py3_shebang_fix %{buildroot}

# Also fix .py.in files
for pyfile in $(grep -rIl '^#!.*python.*$' %{buildroot}) ; do
  %py3_shebang_fix $pyfile
done

sort files.list | uniq > files.list.tmp && mv files.list.tmp files.list

%files -f files.list


%changelog
* Fri Apr 18 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - jazzy.3.2.0-1
- Update to latest release
